#line 1 "C:/Pic18_work/Projects/capture test v2/Capture test v2.c"
#line 31 "C:/Pic18_work/Projects/capture test v2/Capture test v2.c"
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

int BinaryBuffer[40];
int buffer[42];

char *text = "000.0";


char byte_to_Binary(char ap){
 char converted_byte = 0, x=0;
 bit mask_bit;
 text = "     ";
 converted_byte = 0;



 for (x=0; x<8; x++){

 if (BinaryBuffer[ap] == 0)
 mask_bit =0;
 else
 mask_bit =1;


 if (x == 0)
 converted_byte.b7 = mask_bit;

 if (x == 1)
 converted_byte.b6 = mask_bit;
 if (x == 2)
 converted_byte.b5 = mask_bit;
 if (x == 3)
 converted_byte.b4 = mask_bit;
 if (x == 4)
 converted_byte.b3 = mask_bit;
 if (x == 5)
 converted_byte.b2 = mask_bit;
 if (x == 6)
 converted_byte.b1 = mask_bit;
 if (x == 7)
 converted_byte.b0 = mask_bit;

 ap ++;

 }

return converted_byte;
}

void convert_byte_BIN(){
int index =2, bbindex=0;










while(index<42){
 if (buffer[index] <= 0x30) {
 BinaryBuffer[bbindex] = 0;
 }
 if (buffer[index] > 0x30) {
 BinaryBuffer[bbindex] = 1;
 }
 index ++;
 bbindex ++;

 }

}

void number_to_str(int valitem){

text[0] = ' ';
if (valitem & 0x8000){

 text[0]= '-';
 valitem = valitem & 0x7fff;


 }
if (valitem / 100)
 text[1] = valitem /100 + 48;
 else
 text[1] = ' ';
 text[2] = (valitem /10)%10 + 48;
 text[3] = '.';
 text[4] = valitem % 10 + 48;







}
void serial_nlcr(){
uart1_write(0x0d);
uart1_write(0x0a);
}
void data_conversion(){
int debugmode = 0;
char txt[6];
char humid_hi=0, humid_low=0, temp_hi_MM=0, temp_low=0, checksum =0, total = 0, x=0, i=0;
int humid_value =0, tempcelc_value =0;


if (portd.B0 == 1){
debugmode = 1;
 }
 do{
 humid_hi = byte_to_Binary(0);
 humid_low = byte_to_Binary(8);

 temp_hi_MM = byte_to_Binary(16);
 temp_low = byte_to_Binary(24);

 checksum = byte_to_Binary(32);



 total = humid_hi + humid_low + temp_hi_MM + temp_low;


 if (total != checksum){
 TRISD.TRISD2 = 1;
 LATD.LATD2 =1;
 delay_MS(2000);
 if (debugmode ==0);
 {uart1_Write_text("CheckSum Error");}
 serial_nlcr();

 for (x=2; x < 42; x++){
 uart1_write(buffer[x]);

 }
 serial_nlcr();

 for (x=0; x <40; x++)

 {
 uart1_write(BinaryBuffer[x]);
 }
 serial_nlcr();

 uart1_Write(humid_hi);
 uart1_write(humid_low);
 uart1_write(temp_hi_MM);
 uart1_write(temp_low);
 uart1_write(checksum);
 serial_nlcr();

 }
 }
 while(total != checksum);

 LATD.LATD2 = 0;


 humid_value = (humid_hi << 8) | (humid_low & 0xff);
 number_to_str(humid_value);

 if (debugmode ==0){
 uart1_write_text (text);
 uart1_write_text (" Rel Humidity");
 serial_nlcr();
 }
 Lcd_out(1,1,"Rel Humidy");
 Lcd_out_cp(text);
 Lcd_Out_cp("%");


 tempcelc_value = (temp_hi_MM << 8) | (temp_low & 0xff);
 number_to_str(tempcelc_value);

 if (debugmode ==0){
 uart1_write_text(text);
 uart1_write_text(" Temp C");
 serial_nlcr();
 }

 Lcd_out(2,1,"Temp      ");
 Lcd_out_cp(text);
 Lcd_out_cp("c");


 }





char sensor_read(){
char bitcount =0, notvalid =0;
TMR5H = 0;
TMR5L = 0;
PIR5.TMR5IF = 0;
T5CON.T5CKPS1 = 1;
T5CON.T5CKPS0 = 1;
T5CON.TMR5ON = 1;

TRISC.B2 = 0;
LATC.B2 = 0;
Delay_MS(10);
LATC.B2 = 1;
Delay_US(20);
TRISC.B2 = 1;

T1CON.TMR1ON = 0;

TMR1H = 0;
TMR1L = 0;

T1CON.T1CKPS1=1;
T1CON.T1CKPS0=0;

T1CON.TMR1ON;
 while((bitcount <42) && (PIR5.TMR5IF == 0)){
 if (PIR1.CCP1IF == 1){
 T1CON.TMR1ON = 0;
 Buffer[bitcount] = CCPR1;
 TMR1H = 0;
 TMR1L = 0;
 bitcount++ ;
 T1CON.T1CKPS1=1;
 T1CON.T1CKPS0=0;
 PIR1.CCP1IF =0;
 T1CON.TMR1ON = 1;

 }
 }
 T1CON.TMR1ON = 0;
 bitcount=0;
 T5CON.TMR5ON = 0;
 if (PIR5.TMR5IF == 1)
 notvalid = 1;
 else
 notvalid = 0;

 PIR5.TMR5IF == 0;

 return notvalid;


}
void initalise(){


ANSELB = 0;
ANSELC = 0;
ANSELD =0 ;
TRISB.B7 = 0;
TRISC.B2 =1;
TRISD.B0 = 1;

CCP1CON = 0b00000100;

uart1_init(9600);

T1CON.TMR1CS1 = 0;
T1CON.TMR1CS0 = 0;
TMR1H = 0;
TMR1L = 0;
T1CON.TMR1ON = 0;
lcd_init();

}

void main() {
int index =2, bbindex=0;
int bitcount =0;
delay_MS(500);
initalise();
while(1){


 while (sensor_read() == 1){
 LCD_CMD(_LCD_CLEAR);
 LCD_CMD(_LCD_CURSOR_OFF);
 LCD_OUT(1,1,"SENSOR NOT");
 LCD_OUT(2,1,"RESPONDING");
 uart1_write_text("Sensor Not Responding");
 serial_nlcr();
 delay_MS(3000);
 }
 convert_byte_bin();
 LCD_CMD(_LCD_CLEAR);
 LCD_CMD(_LCD_CURSOR_OFF);
 data_conversion();
 delay_MS(10000);
 }
 }
